package edu.columbia.sip;

public class SIPToken extends HTTPToken {

    // Please keep all static members in alphabetical order
    // for readability.
    // Also, when modifying this list remember to update the 
    // isValidParam() method below.
    
    public static final SIPToken ACK = new SIPToken("ACK");
    public static final SIPToken ALSO = new SIPToken("Also");
    public static final SIPToken BYE = new SIPToken("BYE");
    public static final SIPToken CALL_DISPOSITION = new SIPToken("Call-Disposition");
    public static final SIPToken CALL_ID = new SIPToken("Call-ID");
    public static final SIPToken CANCEL = new SIPToken("CANCEL");
    public static final SIPToken EXPIRES = new SIPToken("Expires");
    public static final SIPToken FROM = new SIPToken("From");
    public static final SIPToken GONE = new SIPToken("GONE");
    public static final SIPToken HERE = new SIPToken("HERE");
    public static final SIPToken INVITE = new SIPToken("INVITE");
    public static final SIPToken LOCATION = new SIPToken("Location");
    public static final SIPToken OPTIONS = new SIPToken("OPTIONS");
    public static final SIPToken REGISTER = new SIPToken("REGISTER");
    public static final SIPToken REPLACES = new SIPToken("Replaces");
    public static final SIPToken SIPSEPARATOR = new SIPToken(": ");
    public static final SIPToken SIPVERSION = new SIPToken("SIP/2.0");
    public static final SIPToken STATUS = new SIPToken("STATUS");
    public static final SIPToken TO = new SIPToken("To");
    public static final SIPToken VIA = new SIPToken("Via");
    
    /** not implemented
    private SIPToken() {};
    */

    protected SIPToken(String s) {
        super(s);
    }
 
    
    /**  overriding abstract ProtocolToken.isValidParam()
    */
    public boolean isValidParam(String s) {
        String key = getText();
        
        if (key.equals(ACK.getText())) {
            if (s == null) 
                return true;
            else 
                return false;               
        } 
        
        if (key.equals(ALSO.getText())) {
            if (true /* actually want to test if s is a valid SIP address... */)
                return true;
            else
                return false;
        } // ...etc
        
        return false;
    } // end isValidParam()
    
}